// ALL-IN programma dat alle functies van de Brainbox Robot demonstreert. 
// Bart Huyskens feb2017 meer info op www.e2cre8.be >> Brainbox >> BBR
// !! de code is nogal rommelig omdat dit een samenstelling is van verschillende afzonderlijk geschreven programma's!! Opkuisen staat nog op mijn TODO lijst

// selecteer een mode met switch D22, activeer de mode met switch D8 - stop het programma met de RESET switch

//  MODE                                              | D11 | D13 | D30 | D17 |
//  1-Buzzer + leds                                     0     0     0     1
//  2-Lichtzoeker met 2 fototrans (A0-A1)               0     0     1     0
//  3-Afstandmeter met IR licht D9/A2 & D10/A3          0     0     1     1
//  4-Lijnvolgerdemo (beweeg Z/W lijn onder sensoren)   0     1     0     0
//  5-Alle sensoren - SERIAL MONITOR                    0     1     0     1
//  6-DC motor test                                     0     1     1     0
//  7-LCD demo                                          0     1     1     1
//  8-SERVO MOTOR                                       1     0     0     0
//  9-BLUETOOTH STUREN  (BT comms)                      1     0     0     1


#include "pitches.h"          // bestandje met noten voor muziekstukje, moet mee onder zelfde map als hoofdprogramma staan
#include <Wire.h>             // I2C lib
#include <LiquidCrystal_I2C.h>// https://bitbucket.org/fmalpartida/new-liquidcrystal/downloads
#include <Servo.h>            // servo lib
# include <avr/io.h>          // om echte C code te kunnen schrijven - gebruikt voor bluetooth comms
# include <avr/interrupt.h>   // interrupt code - gebruikt voor BT comms
# define F_CPU 16000000       // Xtal op 16MHz
# define USART_BAUDRATE 9600  // Baudrate op 9600bps - voor BT comms
# define BAUD_PRESCALE (((( F_CPU / 16) + ( USART_BAUDRATE / 2) ) / ( USART_BAUDRATE )) - 1) // Baudrate settings voor BT comms

// koppeling pinnummers aan pinnamen
Servo servo_pin_15;
Servo servo_pin_23;
const int LDRL = A0;   
const int LDRR = A1;   
const int IRL = A2;   
const int IRR = A3;   
const int PWML =  5; 
const int FRL =  14; 
const int PWMR =  6;
const int FRR =  16; 
const int analogOutPin = 13;  
const int BuzzerPin = 7;  
const byte ledPin = 13;
const byte PWM_LEFTMOTOR =  6;    // speed left motor
const byte DIR_LEFTMOTOR =  14;    // direction (forward / backward) left motor
const byte PWM_RIGHTMOTOR =  5;   // speed right motor
const byte DIR_RIGHTMOTOR =  16;  // direction (forward / backward) right motor

//Declaratie van variabelen
volatile byte state = LOW;
volatile byte ReceiveX;
volatile byte ReceiveY;
volatile byte startcomms = 0;
int DC_LEFT = 0;
byte DIR_LEFT = 0;
int DC_RIGHT = 0;
byte DIR_RIGHT = 0;
int sensorValue = 0;       
int outputValue = 0;       
int SWL = 0;
int SWR = 0;
int LNL = 0;
int LNR = 0;
int _ABVAR_1_KEUZE = 0 ;
int a;
bool _ABVAR_3_SW_L= false ;
bool _ABVAR_4_SW_R= false ;
int _ABVAR_5_AFSTAND_L = 0 ;
int _ABVAR_6_AFSTAND_R = 0 ;
int _ABVAR_7_LICHT_L = 0 ;
int _ABVAR_8_LICHT_R = 0 ;
bool _ABVAR_9_LIJN_L= false ;
bool _ABVAR_10_LIJN_R= false ;

void BBR_motors(int L, int R)
{
  if (L<0)
  {
    digitalWrite(14, HIGH);
    int REVL = (255+L); //L is neg zo this is actually 255-L 
    analogWrite(6, REVL);
  }
  else
  {
    digitalWrite(14, LOW);
    analogWrite(6, L);
  }

  if (R<0)
  {
    digitalWrite(16, HIGH);
    int REVR = (255+R); //R is neg so this is actually 255-R 
    analogWrite(5, REVR);
  }
  else
  {
    digitalWrite(16, LOW);
    analogWrite(5, R);
  }
}

//function prototypes
void START();
void AFSTAND();
void MUZIEK();
void LIJN();
void LICHT_ZOEKEN();
void SENSOR_MONITOR();
void DC_MOTOR();
void LCD_DEMO();
void SERVO();
void BT_STUREN();

// setup code bevat instructies die maar één maal moeten worden uitgevoerd - aan het begin van het programma
void setup()
{
  START();                            // STOP de wielen van de robot - afzonderlijke subroutine
    
  // bepalen welke pins input of output zijn
  pinMode( 22, INPUT);
  pinMode( 12, INPUT);
  pinMode( 4, INPUT);
  pinMode( 8, INPUT);
  pinMode( 5, OUTPUT);
  pinMode( 6, OUTPUT);
  pinMode( 17 , OUTPUT);
  pinMode( 30 , OUTPUT);
  pinMode( 13 , OUTPUT);
  pinMode( 11 , OUTPUT);
  pinMode( 14 , OUTPUT);
  pinMode( 16 , OUTPUT);
  pinMode( 9 , OUTPUT);
  pinMode( 10 , OUTPUT);
  servo_pin_15.attach(15);
  servo_pin_23.attach(23);


  
  _ABVAR_1_KEUZE = 1 ;

  for (a=1; a<=  4 ; a++ )  // flash de 4 leds 4x kort aan en uit
  {
    digitalWrite( 17 , LOW );
    digitalWrite( 30 , LOW );
    digitalWrite( 13 , LOW );
    digitalWrite( 11 , LOW );
    delay( 50 );
    digitalWrite( 17 , HIGH );
    digitalWrite( 30 , HIGH );
    digitalWrite( 13 , HIGH );
    digitalWrite( 11 , HIGH );
    delay( 50 );
  }

}

void loop()
{  
  // code om keuzemenustructuur te maken met 4 leds en 2 drukknoppen
  // elke keuze activeert een ander subprogramma
  while ( ( ( _ABVAR_3_SW_L ) == ( false ) ) )
  {
    _ABVAR_3_SW_L = digitalRead(8) ;
    _ABVAR_4_SW_R = digitalRead(22) ;
    if (( ( _ABVAR_4_SW_R ) == ( true ) ))
    {
      _ABVAR_1_KEUZE = ( _ABVAR_1_KEUZE + 1 ) ;
      if (( ( _ABVAR_1_KEUZE ) > ( 9 ) ))
      {
        _ABVAR_1_KEUZE = 1 ;
      }
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 1 ) ))
    {
      digitalWrite( 17 , HIGH );
      digitalWrite( 30 , LOW );
      digitalWrite( 13 , LOW );
      digitalWrite( 11 , LOW );
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 2 ) ))
    {
      digitalWrite( 17 , LOW );
      digitalWrite( 30 , HIGH );
      digitalWrite( 13 , LOW );
      digitalWrite( 11 , LOW );
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 3 ) ))
    {
      digitalWrite( 17 , HIGH );
      digitalWrite( 30 , HIGH);
      digitalWrite( 13 , LOW );
      digitalWrite( 11 , LOW );
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 4 ) ))
    {
      digitalWrite( 17 , LOW );
      digitalWrite( 30 , LOW );
      digitalWrite( 13 , HIGH );
      digitalWrite( 11 , LOW );
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 5 ) ))
    {
      digitalWrite( 17 , HIGH );
      digitalWrite( 30 , LOW );
      digitalWrite( 13 , HIGH );
      digitalWrite( 11 , LOW );
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 6 ) ))
    {
      digitalWrite( 17 , LOW );
      digitalWrite( 30 , HIGH );
      digitalWrite( 13 , HIGH );
      digitalWrite( 11 , LOW );
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 7 ) ))
    {
      digitalWrite( 17 , HIGH );
      digitalWrite( 30 , HIGH );
      digitalWrite( 13 , HIGH );
      digitalWrite( 11 , LOW );
    }
    if (( ( _ABVAR_1_KEUZE ) == ( 8 ) ))
    {
      digitalWrite( 17 , LOW );
      digitalWrite( 30 , LOW );
      digitalWrite( 13 , LOW );
      digitalWrite( 11 , HIGH );
    }   
    if (( ( _ABVAR_1_KEUZE ) == ( 9 ) ))
    {
      digitalWrite( 17 , HIGH );
      digitalWrite( 30 , LOW );
      digitalWrite( 13 , LOW );
      digitalWrite( 11 , HIGH );
    }
    delay( 300 );
  }

  if (( ( _ABVAR_1_KEUZE ) == ( 1 ) ))
  {
    MUZIEK();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 2 ) ))
  {
    LICHT_ZOEKEN();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 3 ) ))
  {
    AFSTAND();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 4 ) ))
  {
    LIJN();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 5 ) ))
  {
    SENSOR_MONITOR();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 6 ) ))
  {
    DC_MOTOR();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 7 ) ))
  {
    LCD_DEMO();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 8 ) ))
  {
    SERVO();
  }
  if (( ( _ABVAR_1_KEUZE ) == ( 9 ) ))
  {
    BT_STUREN();
  }
}

void START()
{
  //STOP ALLE WIELEN om de robot in een veilige toestand te laten starten
  digitalWrite( 14 , LOW );
  analogWrite(6 , 0);
  digitalWrite( 16 , LOW );
  analogWrite(5 , 0);
}

void MUZIEK()
{
// korte melodie Mario Bros
int melody[] = {
  NOTE_E7, NOTE_E7, 0, NOTE_E7, 
  0, NOTE_C7, NOTE_E7, 0,
  NOTE_G7, 0, 0,  0,
  NOTE_G6, 0, 0, 0, 

  NOTE_C7, 0, 0, NOTE_G6, 
  0, 0, NOTE_E6, 0, 
  0, NOTE_A6, 0, NOTE_B6, 
  0, NOTE_AS6, NOTE_A6, 0, 

  NOTE_G6, NOTE_E7, NOTE_G7, 
  NOTE_A7, 0, NOTE_F7, NOTE_G7, 
  0, NOTE_E7, 0,NOTE_C7, 
  NOTE_D7, NOTE_B6, 0, 0,

  NOTE_C7, 0, 0, NOTE_G6, 
  0, 0, NOTE_E6, 0, 
  0, NOTE_A6, 0, NOTE_B6, 
  0, NOTE_AS6, NOTE_A6, 0, 

  NOTE_G6, NOTE_E7, NOTE_G7, 
  NOTE_A7, 0, NOTE_F7, NOTE_G7, 
  0, NOTE_E7, 0,NOTE_C7, 
  NOTE_D7, NOTE_B6, 0, 0
};

//Mario main them tempo
int noteDurations[] = {
  12, 12, 12, 12, 
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12, 

  12, 12, 12, 12,
  12, 12, 12, 12, 
  12, 12, 12, 12, 
  12, 12, 12, 12, 

  9, 9, 9,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,

  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,

  9, 9, 9,
  12, 12, 12, 12,
  12, 12, 12, 12,
  12, 12, 12, 12,
};

  while(1)
  { 
    // iterate over the notes of the melody:
    for (int thisNote = 0; thisNote < 78; thisNote++) 
      {
        // to calculate the note duration, take one second
        // divided by the note type.
        //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
        int noteDuration = 1000 / noteDurations[thisNote];
        tone(7, melody[thisNote], noteDuration);
        // to distinguish the notes, set a minimum time between them.
        // the note's duration + 30% seems to work well:
        int pauseBetweenNotes = noteDuration * 1.30;
        delay(pauseBetweenNotes);
        // stop the tone playing:
        noTone(7);  
    }
  }  
}



void AFSTAND()
{
  // 2 afstandsensoren werken
  while ( true )
  {
    digitalWrite( 9 , HIGH );
    delay( 2 );
    _ABVAR_5_AFSTAND_L = analogRead(2) ;
    digitalWrite( 9 , LOW );
    digitalWrite( 10 , HIGH );
    delay( 2 );
    _ABVAR_6_AFSTAND_R = analogRead(3) ;
    digitalWrite( 10 , LOW );
    if (( ( _ABVAR_5_AFSTAND_L ) > ( 500 ) ))
    {
      digitalWrite( 14 , HIGH );
      analogWrite(6 , 100);
    }
    else
    {
      digitalWrite( 14 , LOW );
      analogWrite(6 , 0);
    }
    if (( ( _ABVAR_6_AFSTAND_R ) > ( 500 ) ))
    {
      digitalWrite( 16 , HIGH );
      analogWrite(5 , 100);
    }
    else
    {
      digitalWrite( 16 , LOW );
      analogWrite(5 , 0);
    }
  }

}

void LICHT_ZOEKEN()
{
  while ( true )
  {
    _ABVAR_7_LICHT_L = analogRead(18) ;
    _ABVAR_8_LICHT_R = analogRead(19) ;
    if (( ( _ABVAR_7_LICHT_L ) == ( _ABVAR_8_LICHT_R ) ))
    {
      digitalWrite( 14 , LOW );
      analogWrite(6 , 0);
      digitalWrite( 16 , LOW );
      analogWrite(5 , 0);
    }
    else
    {
      if (( ( _ABVAR_7_LICHT_L ) > ( _ABVAR_8_LICHT_R ) ))
      {
        digitalWrite( 14 , HIGH );
        analogWrite(6 , 100);
        digitalWrite( 16 , LOW );
        analogWrite(5 , 150);
      }
      else
      {
        digitalWrite( 14 , LOW );
        analogWrite(6 , 150);
        digitalWrite( 16 , HIGH );
        analogWrite(5 , 100);
      }
    }
  }

}

void LIJN()
{
  while ( true )
  {
  if (( ( ( digitalRead(4) ) == ( false ) ) && ( ( digitalRead(12) ) == ( false ) ) ))
  {
    BBR_motors(255,50);
  }
  if (( ( ( digitalRead(4) ) == ( false ) ) && ( ( digitalRead(12) ) == ( true ) ) ))
  {
    BBR_motors(255,255);
  }
  if (( ( ( digitalRead(4) ) == ( true ) ) && ( ( digitalRead(12) ) == ( true ) ) ))
  {
    BBR_motors(50,255);
  }
  if (( ( ( digitalRead(4) ) == ( true ) ) && ( ( digitalRead(12) ) == ( false ) ) ))
  {
    BBR_motors(50,255);
  }
}
  }



void SENSOR_MONITOR()
{
 Serial.begin(9600);                 // zet seriele communicatie op 9600 bps
 while(true)
 {
  sensorValue = analogRead(LDRL);
  Serial.print("\t");    // prints a tab
  Serial.print("LDRL = " );
  Serial.print(sensorValue);

  sensorValue = analogRead(LDRR);
  Serial.print("\t");    // prints a tab
  Serial.print("LDRR = ");
  Serial.print(sensorValue);

  digitalWrite(9, HIGH);
  sensorValue = analogRead(IRL);
  Serial.print("\t");    // prints a tab
  Serial.print("IRL = ");
  Serial.print(sensorValue);
  digitalWrite(9, LOW);

  digitalWrite(10, HIGH);
  sensorValue = analogRead(IRR);
  Serial.print("\t");    // prints a tab
  Serial.print("IRR = ");
  Serial.print(sensorValue);
  digitalWrite(10, LOW);

  SWL = digitalRead(8);
  SWR = digitalRead(22);
  
  Serial.print("\t");    // prints a tab
  Serial.print("SWL = ");
  Serial.print(SWL);  

  Serial.print("\t");    // prints a tab
  Serial.print("SWR = ");
  Serial.print(SWR);

  LNL = digitalRead(4);
  LNR = digitalRead(12);
  
  Serial.print("\t");    // prints a tab
  Serial.print("LNL = ");
  Serial.print(LNL);  

  Serial.print("\t");    // prints a tab
  Serial.print("LNR = ");
  Serial.print(LNR);

  Serial.println(); 

  delay(200); 
 }
}

void DC_MOTOR()
{
  while(true)
 {
    SWL = digitalRead(8) ;
    SWR = digitalRead(22) ;
    if (( ( ( SWL ) == ( HIGH ) ) && ( ( SWR ) == ( LOW ) ) ))
    {
      digitalWrite( 14 , HIGH );
      analogWrite(6 , 0);
      digitalWrite( 16 , LOW );
      analogWrite(5 , 255);
    }
    if (( ( ( SWL ) == ( LOW ) ) && ( ( SWR ) == ( LOW ) ) ))
    {
      digitalWrite( 14 , LOW );
      analogWrite(6 , 255);
      digitalWrite( 16 , LOW );
      analogWrite(5 , 255);
    }
    if (( ( ( SWL ) == ( HIGH ) ) && ( ( SWR ) == ( HIGH ) ) ))
    {
      digitalWrite( 14 , HIGH );
      analogWrite(6 , 0);
      digitalWrite( 16 , HIGH );
      analogWrite(5 , 0);
    }
    if (( ( ( SWL ) == ( LOW ) ) && ( ( SWR ) == ( HIGH ) ) ))
    {
      digitalWrite( 14 , LOW );
      analogWrite(6 , 255);
      digitalWrite( 16 , HIGH );
      analogWrite(5 , 0);
    } 
 } 
}
void LCD_DEMO()
{

int sensorValue = 0;  
int outputValue = 0;  
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address

lcd.begin(16,2);// initialize library
  
  for(int i = 0; i< 3; i++)   // loop 3 times backlight on and off
  {
    lcd.backlight();          //backlight on
    delay(250);
    lcd.noBacklight();        //backlight off
    delay(250);
  }
  
  lcd.backlight();              //backlight on
  lcd.setCursor(0,0);           // set cursor to positon x=0, y=0
  lcd.print("Brainbox");        // print text on the LCD
  delay(500);
  lcd.setCursor(2,1);
  lcd.print("Robotkamp");
  delay(1000); 
  
  while(1)
 {
      lcd.clear();  
      sensorValue = analogRead(A0);              // read the analog value measured at analog pin AN0 
      lcd.setCursor(0,0);                                 // set cursor to positon x,y
      lcd.print("LL:");                            // print text on the LCD
      lcd.print(sensorValue);                             // print the value of the variable on the LCD

      sensorValue = analogRead(A1);              // read the analog value measured at analog pin 
      lcd.setCursor(9,0);                                 // set cursor to positon x,y
      lcd.print("LR:");                            // print text on the LCD
      lcd.print(sensorValue);                             // print the value of the variable on the LCD
      
      digitalWrite(9, HIGH);
      sensorValue = analogRead(A2);
      lcd.setCursor(0,1);                                 // set cursor to positon x,y
      lcd.print("DL:");                            // print text on the LCD
      lcd.print(sensorValue);                             // print the value of the variable on the LCD
      digitalWrite(9, LOW);
    
      digitalWrite(10, HIGH);
      sensorValue = analogRead(A3);
      lcd.setCursor(9,1);                                 // set cursor to positon x,y
      lcd.print("DR:");                            // print text on the LCD
      lcd.print(sensorValue);                             // print the value of the variable on the LCD
      digitalWrite(10, LOW);

      delay(300);                                         // delay of 100msec to avoid flikkering of the LCD  
 } 
}
void SERVO()
{
int x;
while(1)
{
      digitalWrite( 14 , LOW );
      analogWrite(6 , 255);
      digitalWrite( 16 , LOW );
      analogWrite(5 , 255);


   for(x = 1;x<180;x++)
  {
    servo_pin_15.write(x);
    servo_pin_23.write(x);
    delay( 10 );
  }
      digitalWrite( 14 , HIGH );
      analogWrite(6 , 0);
      digitalWrite( 16 , HIGH );
      analogWrite(5 , 0);
      
  for(x = 180;x>0;x--)
  {
    servo_pin_15.write(x );
    servo_pin_23.write(x );
    delay( 10 );
  }
}
}

void BT_STUREN()
{
  LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address
  lcd.begin(16,2);// initialize LCD library
  lcd.backlight();              //backlight on
  lcd.setCursor(0,0);           // set cursor to positon x=0, y=0
  lcd.print("TEST BT BBA_04");    // print text on the LCD

  UCSR1B = (1 << RXEN1 ) | (1 << TXEN1 );     // Enable uart1 for transmit and receive
  UCSR1C = (1 << UCSZ10 ) | (1 << UCSZ11 );
  UBRR1H = (BAUD_PRESCALE >> 8);              // Set baud rate register
  UBRR1L = BAUD_PRESCALE;                    // Set baud rate register
  UCSR1B |= (1 << RXCIE1);                   //Enable interrupt when recieve byte is complete
  sei(); //Enable global interrupts
  
  while(1)
 {
 digitalWrite(ledPin, state);     // flash led D13

if (startcomms == 1){
  if ((ReceiveY >=128)&&(ReceiveX >= 128)) // forward - right
    {
    DIR_LEFT = 0; // forward
    DIR_RIGHT = 0; // forward
    DC_LEFT = ((ReceiveY - 127)*2);
    if (DC_LEFT > 254)DC_LEFT = 255;
    if (DC_LEFT < 0)DC_LEFT = 0;
    DC_RIGHT = ((ReceiveY - 127)*2)-(ReceiveX - 127);
    if (DC_RIGHT > 254)DC_RIGHT = 255;
    if (DC_RIGHT < 0)DC_RIGHT = 0;
    }
    
  else if ((ReceiveY >= 128)&&(ReceiveX <= 127)) // forward left
    {
    DIR_LEFT = 0; // forward
    DIR_RIGHT = 0; // forward
    DC_LEFT = ((ReceiveY - 127)*2)-(127-ReceiveX);
    if (DC_LEFT > 254)DC_LEFT = 255;
    if (DC_LEFT < 0)DC_LEFT = 0;
    DC_RIGHT = ((ReceiveY - 127)*2);
    if (DC_RIGHT > 254)DC_RIGHT = 255;
    if (DC_RIGHT < 0)DC_RIGHT = 0;
    }
    
   else if ((ReceiveY <= 127)&&(ReceiveX <= 127)) // forward left
    {
    DIR_LEFT = 1; // backwards
    DIR_RIGHT = 1; // backwards
    DC_LEFT = 255-(((127-ReceiveY)*2)-(127-ReceiveX));
    if (DC_LEFT > 254)DC_LEFT = 255;
    if (DC_LEFT < 0)DC_LEFT = 0;
    DC_RIGHT = 255-((127-ReceiveY)*2);
    if (DC_RIGHT > 254)DC_RIGHT = 255;
    if (DC_RIGHT < 0)DC_RIGHT = 0;
    }
    else if ((ReceiveY <= 127)&&(ReceiveX >= 128)) // forward left
    {
    DIR_LEFT = 1; // backwards
    DIR_RIGHT = 1; // backwards
    DC_LEFT = 255-((127-ReceiveY)*2);
    if (DC_LEFT > 254)DC_LEFT = 255;
    if (DC_LEFT < 0)DC_LEFT = 0;
    DC_RIGHT = 255-(((127-ReceiveY)*2)-(ReceiveX-127));
    if (DC_RIGHT > 254)DC_RIGHT = 255;
    if (DC_RIGHT < 0)DC_RIGHT = 0;
    }
    else
    {
    DIR_LEFT = 85; // forward
    DIR_RIGHT = 85; // forward
    DC_LEFT =85;
    DC_RIGHT =85;
    }
}
    
 
    analogWrite(PWM_LEFTMOTOR, DC_LEFT);
    digitalWrite(DIR_LEFTMOTOR, DIR_LEFT);
    analogWrite(PWM_RIGHTMOTOR, DC_RIGHT);
    digitalWrite(DIR_RIGHTMOTOR, DIR_RIGHT);

  lcd.clear();                // these LCD lines slow down the whole process a lot. 
  
  lcd.setCursor(0,0);
  lcd.print(ReceiveX); 

  lcd.setCursor(4,0);
  lcd.print(ReceiveY); 

  lcd.setCursor(0,1);
  lcd.print(DIR_LEFT); 

  lcd.setCursor(4,1);
  lcd.print(DC_LEFT); 

  lcd.setCursor(8,1);
  lcd.print(DIR_RIGHT); 

  lcd.setCursor(12,1);
  lcd.print(DC_RIGHT); 
  delay(50);  
 } 
}

ISR (USART1_RX_vect)      // interrupt routine that executes every time a new byte is received
{
    startcomms = 1;
    state = !state;             // inverse the variable "state" to flash led D13
    UCSR1B &= ~(1 << RXCIE1);   // disable RX interrupt
    
    ReceiveX = UDR1;                           // Fetch the received byte value into the variable " ByteReceived " - the RXint flaq is automatically cleared now
    while ((UCSR1A & (1 << RXC1)) == 0) {};         // wait until byte 2 is received
                                                   // Do nothing until data have been received and is ready to be read from UDR 
    ReceiveY = UDR1;                           // receive byte 2
    
    UCSR1B |= (1 << RXCIE1);        //Re-enable RX interrupt
   
}


